<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: Using the Alarm Screen</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Using the Alarm Screen </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>The core component of the NG AS is a dedicated EWO (External Widget Object), which can be placed in WinCC OA panels (like any other EWO), and with some (optional) CTRL code will result in a fully functional Alarm Screen panel.</p>
<p>The main components of the NG AS EWO are illustrated in the following picture:</p>
<p><a class="anchor" id="ewoOverviewPicture"></a></p><div class="image">
<img src="ewoOverview.png" alt=""/>
<div class="caption">
The main components of the NG AS EWO</div></div>
 <ol>
<li>
The filter view area, similar to the existing Alarm Groups functionality: every widget in this area displays statistics of alarms in a selected filter. See <a class="el" href="pageUsingAS.html#secFilterViews">Filter Views (~Alarm Groups)</a>  </li>
<li>
The source control area, used for switching between live and history <a class="el" href="pageUsingAS.html#secSourceTypes">types of source</a>, and for selecting parameters used for archive query.  </li>
<li>
The filter editor area contains a number of widgets, allowing to specify criteria that alarms need to fulfill in order to be visible in the Alarm Table. See <a class="el" href="pageUsingAS.html#secFilterEditor">Filter editor</a>.  </li>
<li>
Alarm Table displays alarms according to the applied filter, grouping and sorting settings. See <a class="el" href="pageUsingAS.html#secAlarmTable">table description</a>.  </li>
<li>
The Footer informs the user about the number of alarms and potential problems affecting their display, such as broken distributed connection. This area also contains a toolbar for performing some common actions (both common and application-specific).  </li>
</ol>
<p>All the AS parts are optional (except for the Alarm Table) - they can be shown or hidden by changing the configuration. In addition, the AS EWO includes two splitters, allowing the source control + filter editor and footer areas to be resized or hidden by dragging the boundary between areas:</p>
<div class="image">
<img src="sliderDragging.png" alt=""/>
<div class="caption">
Resize the filter editor area by dragging the splitter</div></div>
 <h1><a class="anchor" id="secAlarmTable"></a>
The Alarm Table</h1>
<p>The core of the AS EWO is a table that displays selected properties of alarms, according to the applied filtering, grouping and ordering settings. The set of available columns is configured by the project administrator (see <a class="el" href="page_RefJson.html#subsubsec_RefJsonBasicConfigColumns">columns</a>); the set of currently visible columns, as well as their order, can also be configured by the end user (see user settings <a class="el" href="page_UserSettings.html#subsec_UserSettingsColumns">editor</a>).<br  />
</p>
<p>Other elements of the EWO (see <a class="el" href="pageUsingAS.html#ewoOverviewPicture">picture</a>) are mainly used to configure what is displayed in the table and how exactly the information on alarms is displayed.</p>
<h1><a class="anchor" id="secSourceTypes"></a>
Types of alarm sources: live and history modes</h1>
<p>There are two major sources of alarms to be shown in the table: </p><ul>
<li>
<b>Live data</b> coming from the running system(s). When this type of source is selected, a connection to DPEs is performed (using dpQueryConnectSingle()) and the contents of the table reflect the current state of system. The table is immediately updated when any alarm-related events occur in the system.  </li>
<li>
<b>Alarms history</b> with data queried from the archive. With this type of source, the table is filled once, on explicit user's request, and then remains constant until next user request.  </li>
</ul>
<p>The type of the source is selected by combo box, located on the left of the <a class="el" href="pageUsingAS.html#ewoOverviewPicture">source control area</a>. The combo box is only enabled if ORACLE credentials have been entered by the admin; see <a class="el" href="page_ConfigAdmin.html#sec_AdminOracleAccess">ORACLE archive connection</a> for details.</p>
<p><a class="anchor" id="sourceTypeCtlPicture"></a></p><div class="image">
<img src="sourceTypeSelection.png" alt=""/>
<div class="caption">
Source type selection</div></div>
 <p>When <b>History</b> source type is selected - more controls, specific to history source mode, appear next to combo box:</p>
<div class="image">
<img src="sourceHistoryControls.png" alt=""/>
<div class="caption">
Extra controls for history source</div></div>
 <p>These extra controls are buttons, displaying current selection of:</p>
<ol>
<li>
Time interval for query of archived data.  </li>
<li>
Number of systems for which data shall be quesried from archive.  </li>
</ol>
<p>When clicking either of these buttons, popup window appears where the value can be edited. The editor of time interval looks as following:</p>
<div class="image">
<img src="timeRangeEditor.png" alt=""/>
<div class="caption">
Editor of time interval for query</div></div>
 <p>The meaning of types of time interval, which can be selected in combo box, shall be clear from thir names. Some types require extra number to clarify - for example 'last N hours' require the value N to be specified - this value is edited by spinboxa located next to combo box. Two time editor fields (labeled <b>From</b> and <b>to</b>) are used to display the resulting time interval for selected type of interval. They can also be used for direct editing of time interval when <b>Arbitrary</b> interval type is selected.</p>
<p>The editor of systems to select is described in other <a class="el" href="pageUsingAS.html#subSecSystemSelectionArchive">section</a>.</p>
<p>To summarize, the most important differences between the <b>Live</b> and <b>History</b> modes are as follows:</p><ul>
<li>Using the <b>Live</b> source results in displaying the 'current state' (snapshot) of all active alarms in the table, while the <b>History</b> mode displays the sequence of alarms in the selected time range. The differences between them are subtle but very important.</li>
<li>As a consequence of the previous statement, the following observation can be made:<ul>
<li>If both alarms of a pair are active, then for the <b>Live</b> source the user will see both alarms in the table. The table can also be configured to display both alarms in one row.</li>
<li>However, for the <b>History</b> source it is possible that only one alarm of the pair is displayed - for example, if the time of the second alarm in the pair is outside of the selected time range.</li>
</ul>
</li>
<li>The approach for displaying alarms in the <b>Live</b> mode is simple: display all active alarms matching the filters. In the <b>History</b> mode, the approach is completely different: only a limited number of alarms can be shown, as <a class="el" href="page_ConfigAdmin.html#sec_AdminOracleAccess">configured</a> by the admin. The reason for the difference, is an assumption that it is unlikely that a live will contain hundreds of thousands of alarms simultaneously. However, the archives can contain tens of millions of alarms, especially when long time intervals are selected. It was therefore decided that displaying a limited number of alarms is a much better strategy than risking allocating too much memory, especially on shared machines.</li>
<li>No extra configuration is needed for the <b>Live</b> source: the AS can display alarms from any connected distributed system. However, the <b>History</b> source needs information on how to connect to the ORACLE DB containing the archives. Therefore, before switching to the <b>History</b> mode is possible, the admin must enter the appropriate <a class="el" href="page_ConfigAdmin.html#sec_AdminOracleAccess">configuration settings</a>.</li>
<li>The <b>Live</b> source results in a 'live' display: the contents of the table change to reflect the changes in the running system. In contrast, the table is 'frozen' when the <b>History</b> source is used: it displays the result of the last query (with a given time range, systems selection and filter); the contents of the table can only be changed by an explicit user request. <dl class="section note"><dt>Note</dt><dd>The visible contents of the table in the <b>History</b> mode can still be filtered thanks to the <a class="el" href="pageUsingAS.html#subSecQuickFilter">quick filter feature</a>.</dd></dl>
</li>
<li>The <a class="el" href="pageUsingAS.html#ewoOverviewPicture">filter view area</a> only works in the <b>Live</b> mode; the area is hidden when the <b>History</b> source is used.</li>
<li>The <b>History</b> mode may display alarms for DPEs which do not exist in the live system anymore.</li>
</ul>
<h1><a class="anchor" id="secSystemSelection"></a>
Selection of systems</h1>
<p>One of the primary settings for the AS is selecting the list of systems from which alarms shall be displayed. The selection of systems is performed differently depending on whether the Live or History mode is used (see <a class="el" href="pageUsingAS.html#secSourceTypes">Types of alarm sources: live and history modes</a>).</p>
<h2><a class="anchor" id="subSecSystemSelectionLive"></a>
Live alarm source</h2>
<p>For the <b>Live</b> source, the control of the system connections is located on the right-hand side of <a class="el" href="pageUsingAS.html#ewoOverviewPicture">the footer</a>. The widget consists of two parts:</p><ul>
<li>The label displaying the number of systems to which the AS is connected now</li>
<li>The button next to the label allows to connect/disconnect select systems; clicking on the button opens a popup menu with names of available (known) systems</li>
</ul>
<div class="image">
<img src="sysConnectLive.png" alt=""/>
<div class="caption">
System selection in the Live mode</div></div>
 <p>Such widget may be convenient if the system is connected to a few peers. If the list of systems gets very long, another appearance/functionality can be <a class="el" href="page_UserSettings.html#subsec_UserSettingsAppearance">configured</a>:</p><ul>
<li>The 'system map' widget can be displayed in addition to the label with the number of connected systems</li>
<li>The button will now open a dedicated dialog where all systems are shown in a table</li>
</ul>
<p>The system map is a simple rectangular widget, displaying all known systems in a grid, with the color of every cell corresponding to the state of one system:</p><ul>
<li><b>green</b>: the AS is connected to the system</li>
<li><b>yellow</b>: the AS is not connected to the system, but the distributed connection has been established</li>
<li><b>red</b>: connection to system is not available, for example due to the remote system being stopped</li>
</ul>
<p>An example connection map is presented in the following picture, for a use case with four systems:</p>
<div class="image">
<img src="connectionMap.png" alt=""/>
<div class="caption">
Connection map widget</div></div>
 <p>Tooltips for individual cells in the grid display the names of the systems.</p>
<p>The dialog for controlling connections to individual systems is shown in the following picture:</p>
<div class="image">
<img src="sysConnectDialog.png" alt=""/>
<div class="caption">
System connections dialog</div></div>
 <p>In this example, the distributed system consists of four individual systems, so the dialog does not have evident advantages compared to the simple popup menu. However, the situation changes dramatically in large distributed systems.</p>
<p>Both the popup menu and the dialog have indicators showing which systems can not be connected to (for example, system as_test_3 in the pictures above).</p>
<p>Automatic connection to available systems depending on their name is an important feature of the live mode. If a system becomes available when the AS is running in live mode, the AS can connect to it automatically, provided that its name matches one of the patterns defined in the <a class="el" href="page_RefJson.html#subsubsec_RefJsonBasicConfigAlarmSource">configuration</a>.</p>
<h2><a class="anchor" id="subSecSystemSelectionArchive"></a>
History alarm source</h2>
<p>Selection of systems for the History alarm source works differently compared to the Live source. It is performed in a dedicated popup table that appears when the button with the system count is activated (see <a class="el" href="pageUsingAS.html#sourceTypeCtlPicture">picture</a>). All known systems are shown in the table, with additional functionality for selecting multiple systems:</p>
<div class="image">
<img src="sysSelectionPopupTable.png" alt=""/>
<div class="caption">
Selecting systems for history mode queries</div></div>
 <p>Individual systems in the table can still be selected/unselected using checkboxes in the cells. In addition, 'group selection' is possible using the following scenario:</p><ul>
<li>the filter on systems names is entered in the text field</li>
<li>all systems, whose name matches this filter, are highlighted in the table (cyan background)</li>
<li>then the two buttons next to the filter can be used to either select or unselect all the highlighted cells This group selection can be repeated as many times as needed, with different filter texts, until the user is happy with the resulting list of selected systems.</li>
</ul>
<h1><a class="anchor" id="secTableInteractions"></a>
Interacting with alarms in the table</h1>
<p>Once alarms are displayed in the table, the user can perform some actions just by clicking in the cells. Like in other applications, there are two major variants of user actions, initiated by pressing left or right mouse button.</p>
<p>The processing of mouse button clicks is not done by the AS EWO itself, but by Control functions. What exactly is done is defined by a Control function, which is <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigEwoEvents">configurable</a>. The basic implementation of the AS just calls that function, passing enough information about the clicked alarm and pressed mouse button.</p>
<p>As a consequence, this document describes two implementations - for JCOP and UNICOS frameworks - which follow closely the functionality available in the 'old' AS.</p>
<h2><a class="anchor" id="subSecTableInteractionsJcop"></a>
JCOP</h2>
<h3><a class="anchor" id="subSubSecTableInteractionsJcopLeft"></a>
Left mouse button clicks</h3>
<p>The action depends on the column where the mouse click occurred:</p>
<div class="image">
<img src="tableClickableCells.png" alt=""/>
<div class="caption">
Table columns in the default JCOP config</div></div>
 <ol>
<li>
<b>Ack.</b> column (the 'summary' state of alarm acknowledgement): the alarm in the current row will be acknowledged (if possible). Available only in the <b>Live</b> mode.  </li>
<li>
<b>Com</b> column (the number of comments for this alarm): opens the standard WinCC OA panel for editing alarm comments. Available only in the <b>Live</b> mode.  </li>
<li>
<b>&gt;</b> column (column with the name of the default panel): opens a custom panel, related to the alarm, provided that its <b>_panel</b> attribute is not empty.  </li>
<li>
<b>...</b> column: opens the standard WinCC OA panel for viewing alarm details. Available only in the <b>Live</b> mode.  </li>
</ol>
<h3><a class="anchor" id="subSubSecTableInteractionsJcopRight"></a>
Right mouse button</h3>
<p>Pressing right mouse button opens the popup menu <a class="el" href="page_ConfigAdmin.html#sec_AdminPopupMenu">configured</a> by the admin. The default menu configuration (when AS component was just installed) contains the following items:</p>
<div class="image">
<img src="popupMenuJCOP.png" alt=""/>
<div class="caption">
The default popup menu for the JCOP configuration</div></div>
 <ul>
<li>
<b>FSM Panel</b>: opens the FSM panel for the device for which alarm occurred. The item is disabled if the DPE of alarm does not exist (possible in the <b>History</b> mode).  </li>
<li>
<b>Details</b>: opens the standard WinCC OA panel for viewing alarm details. The item is disabled if the table displays alarms for the <b>History</b> <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a>.  </li>
<li>
<b>Trend</b>: opens the trend of the value of the DPE which produced the alarm. The item is disabled for summary alarms, as well as if table displays alarms for the <b>History</b> <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a>. <dl class="section note"><dt>Note</dt><dd>The last limitation is caused by the fact that archived alarms do not contain the <b>_sum</b> attribute.  </dd></dl>
</li>
<li>
<b>Alarm Help</b>: opens the help page for the alarm (see <a class="el" href="page_ConfigAdmin.html#sec_HelpFileTypes">Help File Types</a>). The item is disabled if the DPE of the alarm does not exist (possible in the <b>History</b> mode).  </li>
<li>
<b>Comment Panel</b>: opens the standard WinCC OA panel for editing alarm comments. The item is disabled if the table displays alarms for the <b>History</b> <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a>.  </li>
<li>
<b>Mask Alarm</b>: mask alarm so that it is not shown in table; if the alarm is already masked then the menu item is called <b>Unmask Alarm</b> and its action changes appropriately. Masking is performed by setting the <b>_force_filtered</b> attribute of the alert config. The item is disabled if the table displays alarms for the <b>History</b> <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a>. In addition, this menu item is hidden if the <a class="el" href="page_RefJson.html#subsect_RefJsonBasicConfigSpecificOptions">basic configuration</a> disables alarms masking.  </li>
</ul>
<p>In addition to the logic described above, the admin can set up visibility/availability of individual items in the menu depending on the <a class="el" href="page_ConfigAdmin.html#sec_AccessControl">access rights</a> of the current user.</p>
<h2><a class="anchor" id="subSecTableInteractionsUnicos"></a>
UNICOS</h2>
<h3><a class="anchor" id="subSubSecTableInteractionsUnicosLeft"></a>
Left mouse button</h3>
<p>The action depends on the column where the mouse click occurred: </p><ul>
<li>
<b>Ack.</b> column (the 'summary' state of alarm acknowledgement): all alarms for the device will be acknowledged. This only works if the table displays alarms for the <b>Live</b> <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a>.  </li>
<li>
<b>S</b> column (faceplate existence): opens the faceplate panel for the device. This only works if the table displays alarms for the <b>Live</b> <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a>.  </li>
</ul>
<h3><a class="anchor" id="subSubSecTableInteractionsUnicosRight"></a>
Right mouse button</h3>
<p>Pressing the right mouse button opens a popup menu, but the contents of the menu are very different depending on whether the DPE for which the alarm is displayed still exists in the system (alarms for DPEs removed from the system can be displayed in the table when the <b>History</b> <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a> is used).</p>
<p>When the DPE of the alarm exists, the default popup menu for the UNICOS device is displayed, with some AS-specific additions:</p>
<div class="image">
<img src="unicosPopupMenuNormal.png" alt=""/>
<div class="caption">
The popup menu for a UNICOS device in the AS; DPE exists</div></div>
 <ol>
<li>
Copy the whole line to the clipboard.  </li>
<li>
Open the standard WinCC OA panel for viewing alarm details. The item is disabled if the table displays alarms for the <b>History</b> <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a>.  </li>
<li>
Open the standard WinCC OA panel for editing alarm comments. The item is disabled if the table displays alarms for the <b>History</b> <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a>.  </li>
<li>
Open a submenu allowing to display/hide the columns in table.  </li>
</ol>
<p><br  />
 However, if the DPE of the alarm does not exist anymore, the popup menu is very reduced compared to the menu on picture above:</p>
<div class="image">
<img src="unicosPopupMenuShort.png" alt=""/>
<div class="caption">
The popup menu for a UNICOS device in the AS; DPE does not exists</div></div>
 <h1><a class="anchor" id="secMultiAck"></a>
Acknowledging multiple alarms in one go</h1>
<p>Acknowledging is one of very common tasks when working with alarms. It is used to mark the fact that the user (operator) has seen the alarm and is (probably) taking care of it. The 'acknowledgement state' is a property of every alarm.</p>
<p>Alarms can be acknowledged one by one, or per device (see <a class="el" href="pageUsingAS.html#secTableInteractions">table actions</a>). In addition, the AS provides the possibility to acknowledge multiple alarms in one go. The AS footer contains a button labelled <b>Acknowledge multiple...</b>; clicking this button allows to select one of the multiple acknowledgement modes.</p>
<div class="image">
<img src="ackMultipleMenu.png" alt=""/>
<div class="caption">
Variants of multiple acknowledgement</div></div>
 <p>The labels are meant to be self-explanatory, though some comments could be useful.</p><ul>
<li>The admin can <a class="el" href="page_ConfigAdmin.html#sec_AccessControl">configure</a> the access control such that multiple acknowledgement is available/visible only to a restricted set of users.</li>
<li>Only the alarms contained in the table can be affected by the acknowledgement. For example, if the system contains 1000 alarms, but table only displays 100 of them because of the current <a class="el" href="pageUsingAS.html#secFilterEditor">filter</a>, then only the 100 alarms in table can be acknowledged.</li>
<li>'Selected' means 'selected alarm', not 'selected row'. The difference can be important if the table displays alarms <a class="el" href="pageUsingAS.html#secAlarmTableGrouping">in a tree due to applied grouping</a>: in such case selecting a group node in the tree <b>does not</b> mean selecting all of its child nodes.</li>
<li>Not all alarms, displayed in table, can be acknowledged. The alarms which are already acknowledged are out of scope for these actions. For other alarms, the decision is usually taken based on <b>_ackable</b>, <b>_oldest_ack</b> and <b>_ack_oblig</b> attributes; see the WinCC OA documentation for more details.</li>
<li>The actual operation is not performed by the AS EWO itself, but by Control code; see the <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigEwoEvents">corresponding configuration settings</a>. Two implementations have been developed so far, for JCOP and UNICOS frameworks.</li>
</ul>
<h1><a class="anchor" id="secFilterEditor"></a>
Filter editor</h1>
<p>The filter editor is used to enter filters that specify the criteria that alarms need to fulfill in order to be visible in the alarm table.</p>
<p>There are two types of filters in the filter editor area of the AS EWO:</p>
<div class="image">
<img src="filterEditor.png" alt=""/>
<div class="caption">
Two types of filters</div></div>
 <ol>
<li>
Structured filter contains a number of widgets, with each widget used to specify criteria for a single table column (or, to be more precise, for a single alarm property, and that property does not have to appear as column in the table). Very complex filters can be built if needed by combining criteria for individual properties.  </li>
<li>
Quick filter is used to find occurrences of a given string, wildcard pattern or regular expression in <b>any</b> column of the table  </li>
</ol>
<p>These two types of filters are described in more details in the following sections.</p>
<h2><a class="anchor" id="subSecStructuredFilter"></a>
Structured filters (entered using widgets)</h2>
<p>The structured filter area in the AS is divided horizontally into three distinct parts:</p>
<div class="image">
<img src="filterEditorAreas.png" alt=""/>
<div class="caption">
Structured filter area</div></div>
 <ol>
<li>
<a class="el" href="pageUsingAS.html#subSubSecStructuredFilterEditor">Editor of structured filters</a>  </li>
<li>
<a class="el" href="pageUsingAS.html#subSubSecStructuredFilterButtons">Buttons in the structured filter area</a>  </li>
</ol>
<h3><a class="anchor" id="subSubSecStructuredFilterEditor"></a>
Editor of structured filters</h3>
<p>The structured filter editor allows to build complex filters by combining criteria for individual alarm properties, and then by combining resulting sets of individual filters.</p>
<p>A complete structured filter may be built of several filter sets. In the filter editor, every filter set is shown as a separate tab:</p>
<div class="image">
<img src="filterSets.png" alt=""/>
<div class="caption">
Filter sets of a structured filter</div></div>
 <p>The tab labeled '+' is used for adding new tabs (filter sets) to the filter.</p>
<p>Filters for individual alarm properties in a single tab are joined by logical <b>AND</b>, i.e. an alarm shall match <b>all</b> non-empty filters given in one tab in order to pass the filter. Sets of individual filters defined by tabs can be either used to include alarms matching the criteria to the table, or for excluding them. This is changed using the <b>Filter type</b> radio box. For example, one can create two tabs:</p>
<ul>
<li>
Filter type = include, Alarm text = '<em>error</em>' </li>
<li>
Filter type = exclude, Alarm text = '<em>no error</em>' </li>
</ul>
<p>Combining these two filters will result in displaying all alarms which contain the 'error' string in their alarm text, except for the ones that contain the string 'no error'.</p>
<p>The set of widgets for editing criteria for individual alarm properties on one tab, as well as the rules for working with these widgets, are configurable (see <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigFilterWidget">FilterWidget</a>). Two filtering widgets have been developed so far, for JCOP (fwAlarmScreenNg) and UNICOS (unAlarmScreenNg). There are some common considerations, applicable to all of them.</p>
<p>All available (implemented) filter types can be subdivided into two main categories with respect to the user's ability to edit them:</p>
<ul>
<li>
Editable filters: the user can specify any (allowed/valid) criteria for comparing with the value of alarm property. For example, 'alarm priorities in range 1 to 20', or 'alarm text like <em>error</em>'  </li>
<li>
Fixed filters: the criteria are hard-coded; the user can only choose to switch such filter ON or OFF. The JCOP filter on alarms severity (Warning/Error/Fault) is an example of this behaviour. There is a range of alarm priority values behind each of the buttons (W/E/F), but the users can not edit the range; they can only switch each of the filters ON or OFF.  </li>
</ul>
<p><a class="anchor" id="anchorEditableFilters"></a>Every editable filter may be presented in different forms (== different widgets). The basic implementation includes three different types of widgets for the filter editor:</p>
<ol>
<li>
<p class="startli"><b>String pattern editor</b> is used for filtering strings using patterns with wildcard support. UNIX-style wildcards are supported: the asterisk <b>*</b> character matches zero or more characters; the question mark <b>?</b> matches any single character. </p><dl class="section note"><dt>Note</dt><dd>Other characters can be used as wildcards instead of the standard <b>*</b> and <b>?</b> (e.g. <b>%</b> and <b>_</b>), see <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigWildcards">wildcards</a>. This option can be very useful if the standard wildcard characters are expected to often appear in filtered strings.</dd></dl>
<p>In addition, sets of characters in square brackets can be used, but this is not recommended when the <b>History</b> <a class="el" href="pageUsingAS.html#secSourceTypes">source</a> is used, see <a class="el" href="pageUsingAS.html#subSubSecStructuredFilterHistory">Notes on filtering in the History mode</a>.</p>
<p class="interli">A single editor widget may contain several patterns separated by the semicolon <b>;</b> character; the value of the alarm property will match the filter if it matches any of the patterns. For example, for the 'abc*;def*' pattern, any string starting with 'abc' or 'def' will match.</p>
<p class="interli">Whenever possible, string pattern editors supports completers: when the user starts typing a word, the editor will suggest possible ways of completing the word, based on the word list it was configured with.</p>
<div class="image">
<img src="wordCompleter.png" alt=""/>
<div class="caption">
A completer in action</div></div>
   </li>
<li>
<b>Single value selector</b> is used when only one of possible values should be used for filtering at a time; this is the well-known combo box widget.  </li>
<li>
<p class="startli"><b>Numbers editor</b> is a text editor where one can specify complex criteria for numeric values of alarm properties.</p>
<p class="interli">The filter string may contain several individual rules separated by the comma <b>,</b> character; a numeric value matches the filter if it matches any of the rules. The following rule types are supported: </p><ul>
<li>
Comparison with a single value. For example: <ul>
<li>
<b>123</b> the value must be equal to 123 </li>
<li>
<b>&lt;123</b> the value must be less than 123 </li>
<li>
<b>&gt;123</b> the value must be greater than 123 </li>
</ul>
</li>
<li>
Comparison with a range of values. For example: <b>123-456</b> the value must be in the range from 123 to 456  </li>
</ul>
<p>Both conditions can be prefixed with an exclamation mark (!) to negate the condition, for example:</p>
<p class="endli"><b>!123</b> the value must not be equal to 123  </p>
</li>
</ol>
<h3><a class="anchor" id="subSubSecStructuredFilterButtons"></a>
Buttons in the structured filter area</h3>
<p>The set of buttons related to filters is located on the right side of the filter area.</p>
<div class="image">
<img src="filterButtons.png" alt=""/>
<div class="caption">
Buttons in the filter area</div></div>
 <ol>
<li>
Toggle button for switching between case-sensitive and case-insensitive string comparison; this single setting applies to all string patterns in the filter editor. <dl class="section note"><dt>Note</dt><dd>Be careful when using case-insensitive comparison in the <b>History</b> mode, as this can significantly slow down query execution (see <a class="el" href="pageUsingAS.html#subSubSecStructuredFilterHistory">Notes on filtering in the History mode</a>).  </dd></dl>
</li>
<li>
<p class="startli">Save the current structured filter for future use; this opens the following panel:</p>
<p class="interli"><a class="anchor" id="pictureSaveFilter"></a> </p><div class="image">
<img src="panelSaveFilter.png" alt=""/>
<div class="caption">
Saving the current structured filter</div></div>
 <p class="interli">The functionality of the panel is similar to the standard 'Save file' dialog, available in many editors. The check box 'My Filters' is used to only display the filters saved by the current WinCC OA user.</p>
<p class="endli">The filter is saved in a <a class="el" href="page_RefDp.html#sec_RefDpFilter">dedicated DP</a> as string in the <a class="el" href="page_RefJson.html#subsec_RefJsonFilter">JSON format</a>. </p><dl class="section note"><dt>Note</dt><dd>Even though the <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a> selection control appears to be a part of the filter, its value is not saved with the filter.  </dd></dl>
</li>
<li>
Load and apply a previously saved filter.  </li>
<li>
This label appears when the current contents of the structured filter editor widget differs from the filter applied to the table. This serves as a reminder: don't forget to click the 'Apply' button in order for the new filter to be used.  </li>
<li>
<p class="startli">Clear the contents of the filter editor. In principle, there are two possible interpretations of the term 'clear' in this context: </p><ul>
<li>
Set all filter fields to empty, such that the resulting filter includes all alarms.  </li>
<li>
Display the 'default' filter in the editor. The default filter is a part of previously saved <a class="el" href="page_UserSettings.html">user settings</a>.  </li>
</ul>
<p>If the two options are available at the moment the button was clicked, a small popup menu is presented to the user in order to choose one of the options.</p>
<p class="endli">In either case, clearing the filter means just modifying the contents of the filter editor widget - the new filter is <b>not</b> applied to table automatically.  </p>
</li>
<li>
Apply the filter displayed in the filter editor to the table. Applying the filter works differently for different <a class="el" href="pageUsingAS.html#secSourceTypes">source types</a>: <ul>
<li>
For the <b>Live</b> source, the filter is just applied to the set of known alarms stored in memory; this is typically a very fast operation, unless many thousands of alarms are active in the systems the AS is connected to.  </li>
<li>
For the <b>History</b> source, applying the filter means executing a query on the archives and replacing the current contents of the table with its result.  </li>
</ul>
</li>
</ol>
<h3><a class="anchor" id="subSubSecStructuredFilterHistory"></a>
Notes on filtering in the History mode</h3>
<p>Using structured filters in the <b>History</b> <a class="el" href="pageUsingAS.html#secSourceTypes">mode</a> comes with several important caveats described in this section.</p>
<ul>
<li>
Applying a structured filter in the <b>History</b> mode is performed by executing a query on the archived data. Applying every new filter means executing a new query and the result of the previous query is completely removed. This behavior is different from the <b>Live</b> mode, where all active alarms are cached inside the AS (see <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigModels">AS architecture</a>); applying a new filter in the <b>Live</b> mode just decides which of the cached alarms shall be displayed.  </li>
<li>
It is assumed that the <b>Live</b> alarm source can produce a rather limited number of alarms to be cached by the AS simultaneously, i.e. the number of active alarms is not expected to be extremely high (in the range of hundreds of thousands), at least not during normal operation. In contrast, the <b>History</b> source queries can return a huge number of alarms, especially when long time intervals are selected. In order to prevent the AS from allocating too much memory, the number of alarms retrieved from the archive is <a class="el" href="page_ConfigAdmin.html#sec_AdminOracleAccess">limited by the configuration</a>.  </li>
<li>
<p class="startli">When a filter is applied in the <b>History</b> mode, the AS tries to convert its every field to a corresponding filter predicate in the ORACLE query (typically - extra predicates in the WHERE clause). Ideally, all conditions are mapped in the ORACLE query, but this not always possible. For example, <a class="el" href="pageUsingAS.html#subSubSecStructuredFilterEditor">string patterns</a> that contain a set of characters in square brackets <b>[]</b> cannot be expressed in the ORACLE query.</p>
<p class="endli">For this reason, the filtering is performed in two steps in the <b>History</b> mode: </p><ul>
<li>
First filtering is performed by the predicates in the ORACLE query. </li>
<li>
Then, the query results are additionally filtered by the C++ code, in the same way as in the <b>Live</b> mode. </li>
</ul>
<p>As a consequence, more complex (not fully-translatable) filters are processed differently than simpler (fully-translatable) ones: </p><ul>
<li>
For simple filters, the maximum number of alarms to be returned is specified in the query, allowing ORACLE to take the limit into account and (potentially) to execute the query faster.  </li>
<li>
For complex filters, the maximum number of alarms to be returned is <b>not</b> specified in the query; instead the limit is applied by the AS code during processing of the query results.  </li>
</ul>
<p>clown car  </p>
</li>
<li>
Performance of queries in the history mode can be affected by several issues. Some of them are predictable, but there can be some queries that are unexpectedly slow if the ORACLE database chooses a 'wrong' execution plan. Some examples of predictable reasons for slower query execution: <ul>
<li>
Using case-insensitive string comparison is in general slower compared than case-sensitive.  </li>
<li>
Filtering by string patterns starting with a wildcard (<b>*</b> or <b>?</b>) is in general slower than with wildcards inside (or at the end of) a string pattern.  </li>
<li>
Using criteria on alarm attributes of type <b>langString</b> (e.g. alarm text) is in general slower than criteria on alarm attributes of type <b>string</b> (e.g. alarm DPE) because of the way they are stored in ORACLE archive.  </li>
</ul>
The execution of queries for the <b>History</b> mode can sometimes take very long time. For this reason, the <a class="el" href="pageUsingAS.html#sourceTypeCtlPicture">source control</a> displays a button that allows to abort running the running query. Of course, this does not make query execution faster, but it gives the user a chance to refine the query if the current one is taking too long.  </li>
</ul>
<h2><a class="anchor" id="subSecQuickFilter"></a>
Quick Filter</h2>
<p>The quick filter, located just <a class="el" href="pageUsingAS.html#ewoOverviewPicture">above</a> the table, can be used for searching for rows that contain a text or a pattern in <b>any of the visible columns</b>.</p>
<p>There is no special button for applying the quick filter - it is done immediately when the <b>Enter</b> key is pressed, or when focus leaves the quick filter editor. A quick filter that is not applied yet is indicated with a pale yellow text background.</p>
<p>Unlike rather complex and rich <a class="el" href="pageUsingAS.html#secFilterEditor">structured filter</a>, the quick filter was designed to be very simple, and enable fast searching through the data already displayed in the table. Still, there are some quick filter options can be configured; the configuration popup can be opened by clicking the wrench icon at the beginning of the pattern editor:</p>
<div class="image">
<img src="quickFilterConfig.png" alt=""/>
<div class="caption">
Configuration of the quick filter</div></div>
 <p>All configuration options should be self-explanatory, except for 'Match full column':</p><ul>
<li>if the box is checked then the pattern <b>App</b> in the quick filter does <b>not</b> match the <b>Application</b> string in one of the table columns</li>
<li>if the box is <b>not</b> checked then the pattern <b>App</b> in the quick filter matches the <b>Application</b> string in one of table columns</li>
</ul>
<p>In short - when the box is unchecked, the filter pattern only has to match a part of any of the columns.</p>
<p>Other essential differences between the quick filter and the <a class="el" href="pageUsingAS.html#secFilterEditor">structured filter</a>:</p><ul>
<li>the quick filter can not be <a class="el" href="pageUsingAS.html#subSubSecStructuredFilterButtons">saved</a> for future loading</li>
<li>the quick filter is applied in the same way independently of the <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a>, i.e. applying a new quick filter does not result in a new query to the archive when the <b>History</b> mode is used.</li>
</ul>
<h1><a class="anchor" id="secAlarmTableSort"></a>
Sorting the table</h1>
<p>The order or rows in the table can be changed by clicking the header of a column whose content shall be used for sorting. This works in the Alarm Table, <b>except</b> for the first (grouping) column when alarms are <a class="el" href="pageUsingAS.html#secAlarmTableGrouping">grouped</a>. The sort order in the grouping column is fixed and cannot be changed by clicking the column headers; it can only be changed by <a class="el" href="page_UserSettings.html#subsec_UserSettingsGropuing">editing</a> the user settings. This is done in order to keep the order of groups constant, while still allowing to change the order of alarms in the groups.</p>
<p>Simple 'sort by click' approach only allows to sort alarm by a single column. Sorting by more than one column can be requested in the <a class="el" href="page_UserSettings.html#subsec_UserSettingsSort">the user settings editor</a>.</p>
<h1><a class="anchor" id="secAlarmTableGrouping"></a>
Grouping alarms in the table</h1>
<p>From the visual point of view, the table can operate in two modes:</p>
<ul>
<li>
Flat table mode, as illustrated in the <a class="el" href="pageUsingAS.html#ewoOverviewPicture">picture</a>  </li>
<li>
Tree mode, when alarms are grouped by the values of selected alarm properties. The set of alarm properties for grouping alarms is configurable, see the <a class="el" href="page_UserSettings.html#subsec_UserSettingsGropuing">user settings editor</a>. The following picture illustrates the appearance of the table when two levels of grouping are configured: system name and device type. If grouping is used, then one more column is added to the table as the very first column in row. This extra column displays group nodes; each group node displays the value of the alarm property selected for grouping and the total number of alarms in this group.  </li>
</ul>
<div class="image">
<img src="treeMode.png" alt=""/>
<div class="caption">
Grouping by system name and device type</div></div>
 <p>If the table displays alarms in the tree mode, a special popup menu is available when pressing the right mouse button on tree nodes in the grouping (first) column:</p>
<p><a class="anchor" id="groupNodeMenu"></a></p><div class="image">
<img src="groupNodeMenu.png" alt=""/>
<div class="caption">
Popup menu for group nodes in the tree</div></div>
 <h1><a class="anchor" id="secAlarmTableSelection"></a>
Selecting rows in the table</h1>
<p>Selecting single or multiple rows in the table works like in other tables. However, the interpretation of the selection made by user depends on how this selection is used later, though the difference is only noticeable when the alarms are displayed in the tree mode:</p>
<ul>
<li>
If the selection is used for a 'neutral' purpose (for example: 'export selected to CSV' - see <a class="el" href="pageUsingAS.html#secExportAlarms">Exporting alarms</a>), then selecting a grouping row also means selecting all of the children in this group. In other words, in such cases the selection is automatically propagated down in the tree hierarchy.  </li>
<li>
If the selection is done for a 'potentially dangerous' purpose (for example, to acknowledge <a class="el" href="pageUsingAS.html#secMultiAck">all selected alarms</a>), then the group selection <b>is not</b> propagated down in the tree hierarchy. In order for an alarm to be selected for acknowledgement, its table must be explictly selected - it is not enough to select its parent group.  </li>
</ul>
<h1><a class="anchor" id="secFilterViews"></a>
Filter Views (~Alarm Groups)</h1>
<p>In large systems with many alarms, it is convenient to have an overview of active alarms, providing a summary of the system's state. In such case, the alarm table in the <a class="el" href="pageUsingAS.html#secAlarmTableGrouping">tree mode</a> can be used, but <a class="el" href="pageUsingAS.html#ewoOverviewPicture">Filter views</a> offer a more advanced alternative.</p>
<p>The basic idea is very simple:</p><ul>
<li>The user creates and saves a number of filters, each filter corresponding to a unit of grouping (e.g. one filter per subdetector, or per building).</li>
<li>The filters can then be <a class="el" href="page_FilterViewEditor.html">added to the filter view</a>.</li>
<li>Finally, every filter is shown in filter view area, with the number of active alarms matching that filter.</li>
</ul>
<p>Thus, the overview of a large and complex system can appear in a compact form. The filter view also allows to switch between the filters contained within it by clicking on their corresponding cells, acting as a kind of a clickable 'table of contents' for the system.</p>
<p>The following picture presents an example of a very simple filter view, containing only three items:</p>
<div class="image">
<img src="filterViewExample.png" alt=""/>
<div class="caption">
Example of a simple filter view</div></div>
 <p>Every item in the view displays: the filter name, the total number of active alarms and the number of unacknowledged alarms (in brackets). The background color of every item corresponds to the color of 'the most severe' alarm (in terms of priority) matching this filter.</p>
<p>As mentioned before, clicking on an item in a filter view applies its filter to the table. This also works in the opposite direction: the item of the filter view whose filter matches the current structured filter applied to the table is highlighted (with a thin yellow border - see the item in left top corner on picture above).</p>
<p>The AS provides many options for <a class="el" href="page_FilterViewEditor.html">configuring</a> the contents and appearance for the filter view as a whole as well as for the individual items in the view.</p>
<dl class="section warning"><dt>Warning</dt><dd>Filter views can only be used in the <b>Live</b> <a class="el" href="pageUsingAS.html#secSourceTypes">mode</a> - they are automatically hidden when the <b>History</b> mode is enabled.</dd></dl>
<h1><a class="anchor" id="secExportAlarms"></a>
Exporting alarms</h1>
<p>It is possible to copy the contents of the table to another document, or to save them in some 'commonly understandable' format. The AS provides two features for such operations:</p>
<ul>
<li>
Select one or more rows in the table, then press <b>Ctrl+C</b>. The clipboard now contains the values of all columns in the selected rows, plus the headers. This text can be inserted wherever needed (in a text editor, for example) with the <b>Ctrl+V</b> key combination.  </li>
<li>
<p class="startli">Dedicated button in the <a class="el" href="pageUsingAS.html#ewoOverviewPicture">footer</a> area of the AS:</p>
<div class="image">
<img src="buttonExportCsv.png" alt=""/>
<div class="caption">
The button for exporting the table to a CSV file</div></div>
 <p class="interli">Clicking this button first presents a small dialog with export options:</p>
<div class="image">
<img src="exportCsvOptions.png" alt=""/>
<div class="caption">
Options for exporting the table to a CSV file</div></div>
 <p class="endli">All options in this dialog are self-explanatory, except for the <b>Include grouping</b> check box. It is enabled if the table displays alarms in the <a class="el" href="pageUsingAS.html#secAlarmTableGrouping">tree mode</a>. If the box is checked, then the contents of the grouping (first) column will also be written to the output file.  </p>
</li>
</ul>
<h1><a class="anchor" id="secMessages"></a>
Internal messages</h1>
<p>In addition to the elements of the <a class="el" href="pageUsingAS.html#ewoOverviewPicture">footer area</a> described in previous sections, there is one more element in that part of the AS GUI: the internal message counter.</p>
<p>While the AS operating, it can produce messages of different categories (from debug trace to critical errors). Normally, the messages in WinCC OA are sent to the log, and the AS is not an exception. The logs, however, are almost never checked during normal operation.</p>
<p>To make access to the messages easier, they can be written (depending on the <a class="el" href="page_RefEwo.html#sec_RefEwoPropLog">configuration</a>) to the WinCC OA log and/or to the internal buffer in the AS EWO. The label in the <a class="el" href="pageUsingAS.html#ewoOverviewPicture">footer area</a> of the alarm screen displays the current number of messages in the buffer:</p>
<div class="image">
<img src="msgCounter.png" alt=""/>
<div class="caption">
Message counter</div></div>
 <p>The background color of the counter corresponds to the color of the most severe message in the buffer: </p><ul>
<li>
<b>Red</b> for critical errors </li>
<li>
<b>Yellow</b> for warnings </li>
<li>
<b>Neutral</b> for all other messages (neutral here means default background color) </li>
</ul>
<p>The user can click on this label, which will open the list of stored messages in new window. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
